package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFReminder;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFReminderSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFReminder> selectCond;
	private JSONObject customsearchval;
	public WFReminderSearchFilter(){
		this.page =new Page<WFReminder>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFReminder>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_wfremindername_like;

	public void setN_wfremindername_like(String n_wfremindername_like) {
        this.n_wfremindername_like = n_wfremindername_like;
        if(!StringUtils.isEmpty(this.n_wfremindername_like)){
            this.selectCond.like("wfremindername", n_wfremindername_like);
        }
    }
	private String n_wfstepactorid_eq;

	public void setN_wfstepactorid_eq(String n_wfstepactorid_eq) {
        this.n_wfstepactorid_eq = n_wfstepactorid_eq;
        if(!StringUtils.isEmpty(this.n_wfstepactorid_eq)){
            this.selectCond.eq("wfstepactorid", n_wfstepactorid_eq);
        }
    }
	private String n_wfstepactorname_eq;

	public void setN_wfstepactorname_eq(String n_wfstepactorname_eq) {
        this.n_wfstepactorname_eq = n_wfstepactorname_eq;
        if(!StringUtils.isEmpty(this.n_wfstepactorname_eq)){
            this.selectCond.eq("wfstepactorname", n_wfstepactorname_eq);
        }
    }
	private String n_wfstepactorname_like;

	public void setN_wfstepactorname_like(String n_wfstepactorname_like) {
        this.n_wfstepactorname_like = n_wfstepactorname_like;
        if(!StringUtils.isEmpty(this.n_wfstepactorname_like)){
            this.selectCond.like("wfstepactorname", n_wfstepactorname_like);
        }
    }
	private String n_wfuserid_eq;

	public void setN_wfuserid_eq(String n_wfuserid_eq) {
        this.n_wfuserid_eq = n_wfuserid_eq;
        if(!StringUtils.isEmpty(this.n_wfuserid_eq)){
            this.selectCond.eq("wfuserid", n_wfuserid_eq);
        }
    }
	private String n_wfusername_eq;

	public void setN_wfusername_eq(String n_wfusername_eq) {
        this.n_wfusername_eq = n_wfusername_eq;
        if(!StringUtils.isEmpty(this.n_wfusername_eq)){
            this.selectCond.eq("wfusername", n_wfusername_eq);
        }
    }
	private String n_wfusername_like;

	public void setN_wfusername_like(String n_wfusername_like) {
        this.n_wfusername_like = n_wfusername_like;
        if(!StringUtils.isEmpty(this.n_wfusername_like)){
            this.selectCond.like("wfusername", n_wfusername_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFREMINDER_WFSTEPACTOR_WFSTEPACTORID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfstepactorid_eq("NA");
			}
			else{
				this.setN_wfstepactorid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFREMINDER_WFUSER_WFUSERID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfuserid_eq("NA");
			}
			else{
				this.setN_wfuserid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfremindername",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}